﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.ComponentModel;
using Infragistics.Windows.DataPresenter;

namespace BindingIssue.View
{
    /// <summary>
    /// Interaction logic for Main.xaml
    /// </summary>
    public partial class Main : Page,INotifyPropertyChanged
    {
        public Main()
        {
            InitializeComponent();
            this.DataContext = this;    
        }

        private List<Person> persons;
        public List<Person>Persons
        {
            get { return persons; }
            set
            {
                persons = value;
                this.OnPropertyChanged("Persons");
            }
        }

        private Person selectedPerson;
        public Person SelectedPerson
        {
            get { return selectedPerson; }
            set
            {
                selectedPerson = value;
                this.OnPropertyChanged("SelectedPerson");
            }
        }

        private List<Person> GetData()
        {
            List<Person> people = new List<Person>();
            people.Add(new Person { Name = "Joe Smith", Title = "VP", IsManager = true, Level = 3, HireDate = DateTime.Now.Subtract(TimeSpan.FromDays(1)) });
            people.Add(new Person { Name = "Tom Jones", Title = "Team Leader", IsManager = true, Level = 2, HireDate = DateTime.Now.Subtract(TimeSpan.FromDays(2)) });
            people.Add(new Person { Name = "Bill Bailey", Title = "Salesperson", IsManager = false, Level = 1, HireDate = DateTime.Now.Subtract(TimeSpan.FromDays(3)) });
            people.Add(new Person { Name = "John Doe", Title = "Specialist", IsManager = false, Level = 0, HireDate = DateTime.Now.Subtract(TimeSpan.FromDays(4)) });
            people.Add(new Person { Name = "Jolene Jones", Title = "Writer", IsManager = false, Level = 0, HireDate = DateTime.Now.Subtract(TimeSpan.FromDays(5)) });
            people.Add(new Person { Name = "John Doroski", Title = "Accountant", IsManager = false, Level = 2, HireDate = DateTime.Now.Subtract(TimeSpan.FromDays(6)) });
            people.Add(new Person { Name = "Billiam Clark", Title = "Manager", IsManager = true, Level = 3, HireDate = DateTime.Now.Subtract(TimeSpan.FromDays(7)) });
            people.Add(new Person { Name = "Tomas Lundstrom", Title = "Furrier", IsManager = false, Level = 0, HireDate = DateTime.Now.Subtract(TimeSpan.FromDays(8)) });
            people.Add(new Person { Name = "Harry Carey", Title = "Plumber", IsManager = false, Level = 0, HireDate = DateTime.Now.Subtract(TimeSpan.FromDays(9)) });
            people.Add(new Person { Name = "Harry Carson", Title = "Glazier", IsManager = false, Level = 0, HireDate = DateTime.Now.Subtract(TimeSpan.FromDays(10)) });
            people.Add(new Person { Name = "Happy Rockefeller", Title = "Roofer", IsManager = false, Level = 0, HireDate = DateTime.Now.Subtract(TimeSpan.FromDays(11)) });
            people.Add(new Person { Name = "John Salesman", Title = "Salesman", IsManager = false, Level = 0, HireDate = DateTime.Now.Subtract(TimeSpan.FromDays(12)) });

            //Want to set ActiveDataItem to John Doe
            SelectedPerson = people.ElementAt(3);

            return people;
        }
        

        public class Person
        {
            public Person()
            {

            }

            public string Name { get; set; }
            public string Title { get; set; }
            public int Level { get; set; }
            public bool IsManager { get; set; }
            public DateTime HireDate { get; set; }
            
        }
        #region PropertyChanged
        public event PropertyChangedEventHandler PropertyChanged;

        protected void OnPropertyChanged(PropertyChangedEventArgs e)
        {
            var handler = this.PropertyChanged;
            if (handler != null)
            {
                handler(this, e);
            }
        }

        /// <summary>
        /// Event handler for PropertyChanged events
        /// </summary>
        /// <param name="propertyName">property name</param>
        protected void OnPropertyChanged(string propertyName)
        {
            this.OnPropertyChanged(new PropertyChangedEventArgs(propertyName));
        }
        #endregion

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            Persons = GetData();
        }
    }
}
